Package org.mariadb.jdbc

## Class MariaDbConnection

- java.lang.Object
- - org.mariadb.jdbc.MariaDbConnection

All Implemented Interfaces:
  `AutoCloseable`, `Connection`, `Wrapper`

    public class MariaDbConnection
    extends Object
    implements Connection

### Field Summary

Fields
`ReentrantLock` `lock`
`protected boolean` `nullCatalogMeansCurrent`
`MariaDbPooledConnection` `pooledConnection`

### Fields inherited from interface java.sql.Connection

`TRANSACTION_NONE, TRANSACTION_READ_COMMITTED, TRANSACTION_READ_UNCOMMITTED, TRANSACTION_REPEATABLE_READ, TRANSACTION_SERIALIZABLE`

### Constructor Summary

Constructors
`MariaDbConnection​(Protocol protocol)` Creates a new connection with a given protocol and query factory.

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods Deprecated Methods
`void` `abort​(Executor executor)` Abort connection.
`boolean` `canUseServerTimeout()`
`void` `clearWarnings()` Clears all warnings reported for this `Connection` object.
`ClientSidePreparedStatement` `clientPrepareStatement​(String sql)` Create a new client prepared statement.
`void` `close()` close the connection.
`void` `commit()` Sends commit to the server.
`Array` `createArrayOf​(String typeName, Object[] elements)` Factory method for creating Array objects.
`Blob` `createBlob()` Constructs an object that implements the `Blob` interface.
`Clob` `createClob()` Constructs an object that implements the `Clob` interface.
`NClob` `createNClob()` Constructs an object that implements the `NClob` interface.
`SQLXML` `createSQLXML()` Constructs an object that implements the `SQLXML` interface.
`Statement` `createStatement()` creates a new statement.
`Statement` `createStatement​(int resultSetType, int resultSetConcurrency)` Creates a `Statement` object that will generate `ResultSet` objects with the given type and concurrency.
`Statement` `createStatement​(int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Creates a `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.
`Struct` `createStruct​(String typeName, Object[] attributes)` Factory method for creating Struct objects.
`boolean` `getAutoCommit()` returns true if statements on this connection are auto committed.
`String` `getCatalog()` Retrieves this `Connection` object's current catalog name.
`Properties` `getClientInfo()` Returns a list containing the name and current value of each client info property supported by the driver.
`String` `getClientInfo​(String name)` Returns the value of the client info property specified by name.
`int` `getHoldability()` Retrieves the current holdability of `ResultSet` objects created using this `Connection` object.
`String` `getHostname()` Deprecated.
`int` `getLowercaseTableNames()` Are table case sensitive or not .
`DatabaseMetaData` `getMetaData()` returns the meta data about the database.
`int` `getNetworkTimeout()` Get network timeout.
`protected boolean` `getPinGlobalTxToPhysicalConnection()`
`int` `getPort()` Deprecated.
`protected Protocol` `getProtocol()`
`String` `getSchema()`
`long` `getServerThreadId()`
`int` `getTransactionIsolation()` Retrieves this `Connection` object's current transaction isolation level.
`Map<String,​Class<?>>` `getTypeMap()` Retrieves the `Map` object associated with this `Connection` object.
`String` `getUsername()` Deprecated.
`SQLWarning` `getWarnings()` Retrieves the first warning reported by calls on this `Connection` object.
`boolean` `includeDeadLockInfo()`
`boolean` `includeThreadsTraces()`
`boolean` `isClosed()` checks if the connection is closed.
`boolean` `isReadOnly()` Retrieves whether this `Connection` object is in read-only mode.
`boolean` `isServerMariaDb()`
`boolean` `isValid​(int timeout)` Returns true if the connection has not been closed and is still valid.
`boolean` `isWrapperFor​(Class<?> iface)` Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does.
`String` `nativeSQL​(String sql)`
`static MariaDbConnection` `newConnection​(UrlParser urlParser, GlobalStateInfo globalInfo)` Create new connection Object.
`CallableStatement` `prepareCall​(String sql)` Creates a `CallableStatement` object for calling database stored procedures.
`CallableStatement` `prepareCall​(String sql, int resultSetType, int resultSetConcurrency)` Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency.
`CallableStatement` `prepareCall​(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency.
`PreparedStatement` `prepareStatement​(String sql)` creates a new prepared statement.
`PreparedStatement` `prepareStatement​(String sql, int autoGeneratedKeys)` Creates a default `PreparedStatement` object that has the capability to retrieve auto-generated keys.
`PreparedStatement` `prepareStatement​(String sql, int[] columnIndexes)` Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array.
`PreparedStatement` `prepareStatement​(String sql, int resultSetType, int resultSetConcurrency)` Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type and concurrency.
`PreparedStatement` `prepareStatement​(String sql, int resultSetType, int resultSetConcurrency, int resultSetHoldability)` Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.
`PreparedStatement` `prepareStatement​(String sql, String[] columnNames)` Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array.
`static String` `quoteIdentifier​(String string)`
`void` `reenableWarnings()` Re-enable warnings, when next statement is executed.
`void` `releaseSavepoint​(Savepoint savepoint)` Removes the specified `Savepoint` and subsequent `Savepoint` objects from the current transaction.
`void` `reset()` Reset connection set has it was after creating a "fresh" new connection.
`void` `rollback()` Rolls back a transaction.
`void` `rollback​(Savepoint savepoint)` Undoes all changes made after the given `Savepoint` object was set.
`ServerSidePreparedStatement` `serverPrepareStatement​(String sql)` Create a new server prepared statement.
`void` `setAutoCommit​(boolean autoCommit)` Sets whether this connection is auto committed.
`void` `setCatalog​(String catalog)` Sets the given catalog name in order to select a subspace of this `Connection` object's database in which to work.
`void` `setClientInfo​(String name, String value)` Sets the value of the client info property specified by name to the value specified by value.
`void` `setClientInfo​(Properties properties)` Sets the value of the connection's client info properties.
`void` `setDefaultTransactionIsolation​(int defaultTransactionIsolation)`
`void` `setHoldability​(int holdability)` Changes the default holdability of `ResultSet` objects created using this `Connection` object to the given holdability.
`void` `setHostFailed()` If failover is not activated, will close connection when a connection error occur.
`void` `setNetworkTimeout​(Executor executor, int milliseconds)` Change network timeout.
`void` `setReadOnly​(boolean readOnly)` Sets whether this connection is read only.
`Savepoint` `setSavepoint()` Creates an unnamed savepoint in the current transaction and returns the new `Savepoint *` object that represents it.
`Savepoint` `setSavepoint​(String name)` Creates a savepoint with the given name in the current transaction and returns the new `Savepoint` object that represents it.
`void` `setSchema​(String arg0)`
`void` `setTransactionIsolation​(int level)` Attempts to change the transaction isolation level for this `Connection` object to the one given.
`void` `setTypeMap​(Map<String,​Class<?>> map)` Installs the given `TypeMap` object as the type map for this `Connection` object.
`static String` `unquoteIdentifier​(String string)` Deprecated. since 1.3.0
`<T> T` `unwrap​(Class<T> iface)` Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy.
`boolean` `versionGreaterOrEqual​(int major, int minor, int patch)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.sql.Connection

`beginRequest, endRequest, setShardingKey, setShardingKey, setShardingKeyIfValid, setShardingKeyIfValid`

### Field Detail

#### lock

    public final ReentrantLock lock

#### pooledConnection

    public MariaDbPooledConnection pooledConnection

#### nullCatalogMeansCurrent

    protected boolean nullCatalogMeansCurrent

### Constructor Detail

#### MariaDbConnection

    public MariaDbConnection​(Protocol protocol)

Creates a new connection with a given protocol and query factory.

Parameters:
  `protocol` - the protocol to use.

### Method Detail

#### newConnection

    public static MariaDbConnection newConnection​(UrlParser urlParser,
                                                  GlobalStateInfo globalInfo)
                                           throws SQLException

Create new connection Object.

Parameters:
  `urlParser` - parser
  `globalInfo` - global info
Returns:
  connection object
Throws:
  `SQLException` - if any connection error occur

#### quoteIdentifier

    public static String quoteIdentifier​(String string)

#### unquoteIdentifier

    @Deprecated
    public static String unquoteIdentifier​(String string)

Deprecated.
since 1.3.0
UnQuote string.

Parameters:
  `string` - value
Returns:
  unquote string

#### getProtocol

    protected Protocol getProtocol()

#### createStatement

    public Statement createStatement()
                              throws SQLException

creates a new statement.

Specified by:
  `createStatement` in interface `Connection`
Returns:
  a statement
Throws:
  `SQLException` - if we cannot create the statement.

#### createStatement

    public Statement createStatement​(int resultSetType,
                                     int resultSetConcurrency)

Creates a `Statement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `createStatement` method above, but it allows the default result set type and concurrency to be overridden. The holdability of the created result sets can be determined by calling `getHoldability()`.

Specified by:
  `createStatement` in interface `Connection`
Parameters:
  `resultSetType` - a result set type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  `resultSetConcurrency` - a concurrency type; one of `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
Returns:
  a new `Statement` object that will generate `ResultSet` objects with the given type and concurrency

#### createStatement

    public Statement createStatement​(int resultSetType,
                                     int resultSetConcurrency,
                                     int resultSetHoldability)

Creates a `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability. This method is the same as the `createStatement` method above, but it allows the default result set type, concurrency, and holdability to be overridden.

Specified by:
  `createStatement` in interface `Connection`
Parameters:
  `resultSetType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  `resultSetConcurrency` - one of the following `ResultSet` constants: `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
  `resultSetHoldability` - one of the following `ResultSet` constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Returns:
  a new `Statement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability
See Also:
  `ResultSet`

#### clientPrepareStatement

    public ClientSidePreparedStatement clientPrepareStatement​(String sql)
                                                       throws SQLException

Create a new client prepared statement.

Parameters:
  `sql` - the query.
Returns:
  a client prepared statement.
Throws:
  `SQLException` - if there is a problem preparing the statement.

#### serverPrepareStatement

    public ServerSidePreparedStatement serverPrepareStatement​(String sql)
                                                       throws SQLException

Create a new server prepared statement.

Parameters:
  `sql` - the query.
Returns:
  a server prepared statement.
Throws:
  `SQLException` - if there is a problem preparing the statement.

#### prepareStatement

    public PreparedStatement prepareStatement​(String sql)
                                       throws SQLException

creates a new prepared statement.

Specified by:
  `prepareStatement` in interface `Connection`
Parameters:
  `sql` - the query.
Returns:
  a prepared statement.
Throws:
  `SQLException` - if there is a problem preparing the statement.

#### prepareStatement

    public PreparedStatement prepareStatement​(String sql,
                                              int resultSetType,
                                              int resultSetConcurrency)
                                       throws SQLException

Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareStatement` method above, but it allows the default result set type and concurrency to be overridden. The holdability of the created result sets can be determined by calling `getHoldability()`.

Specified by:
  `prepareStatement` in interface `Connection`
Parameters:
  `sql` - a `String` object that is the SQL statement to be sent to the database; may contain one or more '?' IN parameters
  `resultSetType` - a result set type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  `resultSetConcurrency` - a concurrency type; one of `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
Returns:
  a new PreparedStatement object containing the pre-compiled SQL statement that will produce `ResultSet` objects with the given type and concurrency
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed connection or the given parameters are not`ResultSet` constants indicating type and concurrency

#### prepareStatement

    public PreparedStatement prepareStatement​(String sql,
                                              int resultSetType,
                                              int resultSetConcurrency,
                                              int resultSetHoldability)
                                       throws SQLException

Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type, concurrency, and holdability.

This method is the same as the `prepareStatement` method above, but it allows the default result set type, concurrency, and holdability to be overridden.

Specified by:
  `prepareStatement` in interface `Connection`
Parameters:
  `sql` - a `String` object that is the SQL statement to be sent to the database; may contain one or more '?' IN parameters
  `resultSetType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  `resultSetConcurrency` - one of the following `ResultSet` constants: `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
  `resultSetHoldability` - one of the following `ResultSet` constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Returns:
  a new `PreparedStatement` object, containing the pre-compiled SQL statement, that will generate `ResultSet` objects with the given type, concurrency, and holdability
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed connection or the given parameters are not `ResultSet` constants indicating type, concurrency, and holdability
See Also:
  `ResultSet`

#### prepareStatement

    public PreparedStatement prepareStatement​(String sql,
                                              int autoGeneratedKeys)
                                       throws SQLException

Creates a default `PreparedStatement` object that has the capability to retrieve auto-generated keys. The given constant tells the driver whether it should make auto-generated keys available for retrieval. This parameter is ignored if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` object is executed. This has no direct effect on users; however, it does affect which methods throw certain SQLExceptions.

Result sets created using the returned `PreparedStatement` object will by default be type `TYPE_FORWARD_ONLY` and have a concurrency level of `CONCUR_READ_ONLY` . The holdability of the created result sets can be determined by calling `getHoldability()`.

Specified by:
  `prepareStatement` in interface `Connection`
Parameters:
  `sql` - an SQL statement that may contain one or more '?' IN parameter placeholders
  `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be returned; one of `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`
Returns:
  a new `PreparedStatement` object, containing the pre-compiled SQL statement, that will have the capability of returning auto-generated keys
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed connection or the given parameter is not a `Statement` constant indicating whether auto-generated keys should be returned

#### prepareStatement

    public PreparedStatement prepareStatement​(String sql,
                                              int[] columnIndexes)
                                       throws SQLException

Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

An SQL statement with or without IN parameters can be pre-compiled and stored in a `PreparedStatement` object. This object can then be used to efficiently execute this statement multiple times.

Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` object is executed. This has no direct effect on users; however, it does affect which methods throw certain SQLExceptions.

Result sets created using the returned `PreparedStatement` object will by default be type `TYPE_FORWARD_ONLY` and have a concurrency level of `CONCUR_READ_ONLY` . The holdability of the created result sets can be determined by calling `getHoldability()`.

Specified by:
  `prepareStatement` in interface `Connection`
Parameters:
  `sql` - an SQL statement that may contain one or more '?' IN parameter placeholders
  `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row or rows
Returns:
  a new `PreparedStatement` object, containing the pre-compiled statement, that is capable of returning the auto-generated keys designated by the given array of column indexes
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed connection

#### prepareStatement

    public PreparedStatement prepareStatement​(String sql,
                                              String[] columnNames)
                                       throws SQLException

Creates a default `PreparedStatement` object capable of returning the auto-generated keys designated by the given array. This array contains the names of the columns in the target table that contain the auto-generated keys that should be returned. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

An SQL statement with or without IN parameters can be pre-compiled and stored in a `PreparedStatement` object. This object can then be used to efficiently execute this statement multiple times.

Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` object is executed. This has no direct effect on users; however, it does affect which methods throw certain SQLExceptions.

Result sets created using the returned `PreparedStatement` object will by default be type `TYPE_FORWARD_ONLY` and have a concurrency level of `CONCUR_READ_ONLY` . The holdability of the created result sets can be determined by calling `getHoldability()`.

Specified by:
  `prepareStatement` in interface `Connection`
Parameters:
  `sql` - an SQL statement that may contain one or more '?' IN parameter placeholders
  `columnNames` - an array of column names indicating the columns that should be returned from the inserted row or rows
Returns:
  a new `PreparedStatement` object, containing the pre-compiled statement, that is capable of returning the auto-generated keys designated by the given array of column names
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed connection

#### prepareCall

    public CallableStatement prepareCall​(String sql)
                                  throws SQLException

Creates a `CallableStatement` object for calling database stored procedures. The `CallableStatement` object provides methods for setting up its IN and OUT parameters, and methods for executing the call to a stored procedure. example : {?= call <procedure-name>[(<arg1>,<arg2>, ...)]} or {call <procedure-name>[(<arg1>,<arg2>, ...)]}

Note: This method is optimized for handling stored procedure call statements.

Specified by:
  `prepareCall` in interface `Connection`
Parameters:
  `sql` - an SQL statement that may contain one or more '?' parameter placeholders. Typically this statement is specified using JDBC call escape syntax.
Returns:
  a new default `CallableStatement` object containing the pre-compiled SQL statement
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed connection

#### prepareCall

    public CallableStatement prepareCall​(String sql,
                                         int resultSetType,
                                         int resultSetConcurrency)
                                  throws SQLException

Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareCall` method above, but it allows the default result set type and concurrency to be overridden. The holdability of the created result sets can be determined by calling `getHoldability()`.

Specified by:
  `prepareCall` in interface `Connection`
Parameters:
  `sql` - a `String` object that is the SQL statement to be sent to the database; may contain on or more '?' parameters
  `resultSetType` - a result set type; one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  `resultSetConcurrency` - a concurrency type; one of `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
Returns:
  a new `CallableStatement` object containing the pre-compiled SQL statement that will produce `ResultSet` objects with the given type and concurrency
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed connection or the given parameters are not `ResultSet` constants indicating type and concurrency

#### prepareCall

    public CallableStatement prepareCall​(String sql,
                                         int resultSetType,
                                         int resultSetConcurrency,
                                         int resultSetHoldability)
                                  throws SQLException

Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareCall` method above, but it allows the default result set type, result set concurrency type and holdability to be overridden.

Specified by:
  `prepareCall` in interface `Connection`
Parameters:
  `sql` - a `String` object that is the SQL statement to be sent to the database; may contain on or more '?' parameters
  `resultSetType` - one of the following `ResultSet` constants: `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`
  `resultSetConcurrency` - one of the following `ResultSet` constants: `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`
  `resultSetHoldability` - one of the following `ResultSet` constants: `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Returns:
  a new `CallableStatement` object, containing the pre-compiled SQL statement, that will generate `ResultSet` objects with the given type, concurrency, and holdability
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed connection or the given parameters are not `ResultSet` constants indicating type, concurrency, and holdability
See Also:
  `ResultSet`

#### nativeSQL

    public String nativeSQL​(String sql)
                     throws SQLException

Specified by:
  `nativeSQL` in interface `Connection`
Throws:
  `SQLException`

#### getAutoCommit

    public boolean getAutoCommit()
                          throws SQLException

returns true if statements on this connection are auto committed.

Specified by:
  `getAutoCommit` in interface `Connection`
Returns:
  true if auto commit is on.
Throws:
  `SQLException` - if there is an error

#### setAutoCommit

    public void setAutoCommit​(boolean autoCommit)
                       throws SQLException

Sets whether this connection is auto committed.

Specified by:
  `setAutoCommit` in interface `Connection`
Parameters:
  `autoCommit` - if it should be auto committed.
Throws:
  `SQLException` - if something goes wrong talking to the server.

#### commit

    public void commit()
                throws SQLException

Sends commit to the server.

Specified by:
  `commit` in interface `Connection`
Throws:
  `SQLException` - if there is an error committing.

#### rollback

    public void rollback()
                  throws SQLException

Rolls back a transaction.

Specified by:
  `rollback` in interface `Connection`
Throws:
  `SQLException` - if there is an error rolling back.

#### rollback

    public void rollback​(Savepoint savepoint)
                  throws SQLException

Undoes all changes made after the given `Savepoint` object was set.

This method should be used only when auto-commit has been disabled.

Specified by:
  `rollback` in interface `Connection`
Parameters:
  `savepoint` - the `Savepoint` object to roll back to
Throws:
  `SQLException` - if a database access error occurs, this method is called while participating in a distributed transaction, this method is called on a closed connection, the `Savepoint` object is no longer valid, or this `Connection` object is currently in auto-commit mode
See Also:
  `Savepoint`, `rollback()`

#### close

    public void close()
               throws SQLException

close the connection.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Connection`
Throws:
  `SQLException` - if there is a problem talking to the server.

#### isClosed

    public boolean isClosed()

checks if the connection is closed.

Specified by:
  `isClosed` in interface `Connection`
Returns:
  true if the connection is closed

#### getMetaData

    public DatabaseMetaData getMetaData()

returns the meta data about the database.

Specified by:
  `getMetaData` in interface `Connection`
Returns:
  meta data about the db.

#### isReadOnly

    public boolean isReadOnly()
                       throws SQLException

Retrieves whether this `Connection` object is in read-only mode.

Specified by:
  `isReadOnly` in interface `Connection`
Returns:
  `true` if this `Connection` object is read-only; `false` otherwise
Throws:
  `SQLException` - SQLException if a database access error occurs or this method is called on a closed connection

#### setReadOnly

    public void setReadOnly​(boolean readOnly)
                     throws SQLException

Sets whether this connection is read only.

Specified by:
  `setReadOnly` in interface `Connection`
Parameters:
  `readOnly` - true if it should be read only.
Throws:
  `SQLException` - if there is a problem

#### getCatalog

    public String getCatalog()
                      throws SQLException

Retrieves this `Connection` object's current catalog name.

Specified by:
  `getCatalog` in interface `Connection`
Returns:
  the current catalog name or `null` if there is none
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed connection
See Also:
  `setCatalog(java.lang.String)`

#### setCatalog

    public void setCatalog​(String catalog)
                    throws SQLException

Sets the given catalog name in order to select a subspace of this `Connection` object's database in which to work.

If the driver does not support catalogs, it will silently ignore this request. MariaDB treats catalogs and databases as equivalent

Specified by:
  `setCatalog` in interface `Connection`
Parameters:
  `catalog` - the name of a catalog (subspace in this `Connection` object's database) in which to work
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed connection
See Also:
  `getCatalog()`

#### isServerMariaDb

    public boolean isServerMariaDb()
                            throws SQLException

Throws:
  `SQLException`

#### versionGreaterOrEqual

    public boolean versionGreaterOrEqual​(int major,
                                         int minor,
                                         int patch)

#### getTransactionIsolation

    public int getTransactionIsolation()
                                throws SQLException

Retrieves this `Connection` object's current transaction isolation level.

Specified by:
  `getTransactionIsolation` in interface `Connection`
Returns:
  the current transaction isolation level, which will be one of the following constants: `Connection.TRANSACTION_READ_UNCOMMITTED`, `Connection.TRANSACTION_READ_COMMITTED`, `Connection.TRANSACTION_REPEATABLE_READ` , `Connection.TRANSACTION_SERIALIZABLE`, or `Connection.TRANSACTION_NONE`.
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed connection
See Also:
  `setTransactionIsolation(int)`

#### setTransactionIsolation

    public void setTransactionIsolation​(int level)
                                 throws SQLException

Attempts to change the transaction isolation level for this `Connection` object to the one given. The constants defined in the interface `Connection` are the possible transaction isolation levels.

Note: If this method is called during a transaction, the result is implementation-defined.

Specified by:
  `setTransactionIsolation` in interface `Connection`
Parameters:
  `level` - one of the following `Connection` constants: `Connection.TRANSACTION_READ_UNCOMMITTED`, `Connection.TRANSACTION_READ_COMMITTED` , `Connection.TRANSACTION_REPEATABLE_READ`, or `Connection.TRANSACTION_SERIALIZABLE`. (Note that `Connection.TRANSACTION_NONE` cannot be used because it specifies that transactions are not supported.)
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed connection or the given parameter is not one of the `Connection` constants
See Also:
  `DatabaseMetaData.supportsTransactionIsolationLevel(int)`, `getTransactionIsolation()`

#### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

Retrieves the first warning reported by calls on this `Connection` object. If there is more than one warning, subsequent warnings will be chained to the first one and can be retrieved by calling the method `SQLWarning.getNextWarning` on the warning that was retrieved previously.

This method may not be called on a closed connection; doing so will cause an `SQLException` to be thrown.

Note: Subsequent warnings will be chained to this SQLWarning.

Specified by:
  `getWarnings` in interface `Connection`
Returns:
  the first `SQLWarning` object or `null` if there are none
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed connection
See Also:
  `SQLWarning`

#### clearWarnings

    public void clearWarnings()
                       throws SQLException

Clears all warnings reported for this `Connection` object. After a call to this method, the method `getWarnings` returns `null` until a new warning is reported for this `Connection` object.

Specified by:
  `clearWarnings` in interface `Connection`
Throws:
  `SQLException` - SQLException if a database access error occurs or this method is called on a closed connection

#### reenableWarnings

    public void reenableWarnings()

Re-enable warnings, when next statement is executed.

#### getTypeMap

    public Map<String,​Class<?>> getTypeMap()

Retrieves the `Map` object associated with this `Connection` object. Unless the application has added an entry, the type map returned will be empty.

Specified by:
  `getTypeMap` in interface `Connection`
Returns:
  the `java.util.Map` object associated with this `Connection` object
Since:
  1.2
See Also:
  `setTypeMap(java.util.Map<java.lang.String, java.lang.Class<?>>)`

#### setTypeMap

    public void setTypeMap​(Map<String,​Class<?>> map)
                    throws SQLException

Installs the given `TypeMap` object as the type map for this `Connection` object. The type map will be used for the custom mapping of SQL structured types and distinct types.

Specified by:
  `setTypeMap` in interface `Connection`
Parameters:
  `map` - the `java.util.Map` object to install as the replacement for this `Connection` object's default type map
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed connection or the given parameter is not a `java.util.Map` object
See Also:
  `getTypeMap()`

#### getHoldability

    public int getHoldability()

Retrieves the current holdability of `ResultSet` objects created using this `Connection` object.

Specified by:
  `getHoldability` in interface `Connection`
Returns:
  the holdability, one of `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
Since:
  1.4
See Also:
  `setHoldability(int)`, `DatabaseMetaData.getResultSetHoldability()`, `ResultSet`

#### setHoldability

    public void setHoldability​(int holdability)

Changes the default holdability of `ResultSet` objects created using this `Connection` object to the given holdability. The default holdability of `ResultSet` objects can be be determined by invoking `DatabaseMetaData.getResultSetHoldability()`.

Specified by:
  `setHoldability` in interface `Connection`
Parameters:
  `holdability` - a `ResultSet` holdability constant; one of `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`
See Also:
  `getHoldability()`, `DatabaseMetaData.getResultSetHoldability()`, `ResultSet`

#### setSavepoint

    public Savepoint setSavepoint()
                           throws SQLException

Creates an unnamed savepoint in the current transaction and returns the new `Savepoint *` object that represents it.

if setSavepoint is invoked outside of an active transaction, a transaction will be started at this newly created savepoint.

Specified by:
  `setSavepoint` in interface `Connection`
Returns:
  the new `Savepoint` object
Throws:
  `SQLException` - if a database access error occurs, this method is called while participating in a distributed transaction, this method is called on a closed connection or this `Connection` object is currently in auto-commit mode
Since:
  1.4
See Also:
  `Savepoint`

#### setSavepoint

    public Savepoint setSavepoint​(String name)
                           throws SQLException

Creates a savepoint with the given name in the current transaction and returns the new `Savepoint` object that represents it. if setSavepoint is invoked outside of an active transaction, a transaction will be started at this newly created savepoint.

Specified by:
  `setSavepoint` in interface `Connection`
Parameters:
  `name` - a `String` containing the name of the savepoint
Returns:
  the new `Savepoint` object
Throws:
  `SQLException` - if a database access error occurs, this method is called while participating in a distributed transaction, this method is called on a closed connection or this `Connection` object is currently in auto-commit mode
Since:
  1.4
See Also:
  `Savepoint`

#### releaseSavepoint

    public void releaseSavepoint​(Savepoint savepoint)
                          throws SQLException

Removes the specified `Savepoint` and subsequent `Savepoint` objects from the current transaction. Any reference to the savepoint after it have been removed will cause an `SQLException` to be thrown.

Specified by:
  `releaseSavepoint` in interface `Connection`
Parameters:
  `savepoint` - the `Savepoint` object to be removed
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed connection or the given `Savepoint` object is not a valid savepoint in the current transaction

#### createClob

    public Clob createClob()

Constructs an object that implements the `Clob` interface. The object returned initially contains no data. The `setAsciiStream`, `setCharacterStream` and `setString` methods of the `Clob` interface may be used to add data to the `Clob`.

Specified by:
  `createClob` in interface `Connection`
Returns:
  An object that implements the `Clob` interface

#### createBlob

    public Blob createBlob()

Constructs an object that implements the `Blob` interface. The object returned initially contains no data. The `setBinaryStream` and `setBytes` methods of the `Blob` interface may be used to add data to the `Blob`.

Specified by:
  `createBlob` in interface `Connection`
Returns:
  An object that implements the `Blob` interface

#### createNClob

    public NClob createNClob()

Constructs an object that implements the `NClob` interface. The object returned initially contains no data. The `setAsciiStream`, `setCharacterStream` and `setString` methods of the `NClob` interface may be used to add data to the `NClob`.

Specified by:
  `createNClob` in interface `Connection`
Returns:
  An object that implements the `NClob` interface

#### createSQLXML

    public SQLXML createSQLXML()
                        throws SQLException

Constructs an object that implements the `SQLXML` interface. The object returned initially contains no data. The `createXmlStreamWriter` object and `setString` method of the `SQLXML` interface may be used to add data to the `SQLXML` object.

Specified by:
  `createSQLXML` in interface `Connection`
Returns:
  An object that implements the `SQLXML` interface
Throws:
  `SQLException` - if an object that implements the `SQLXML` interface can not be constructed, this method is called on a closed connection or a database access error occurs.

#### isValid

    public boolean isValid​(int timeout)
                    throws SQLException

Returns true if the connection has not been closed and is still valid. The driver shall submit a query on the connection or use some other mechanism that positively verifies the connection is still valid when this method is called.

The query submitted by the driver to validate the connection shall be executed in the context of the current transaction.

Specified by:
  `isValid` in interface `Connection`
Parameters:
  `timeout` - - The time in seconds to wait for the database operation used to validate the connection to complete. If the timeout period expires before the operation completes, this method returns false. A value of 0 indicates a timeout is not applied to the database operation.
Returns:
  true if the connection is valid, false otherwise
Throws:
  `SQLException` - if the value supplied for `timeout` is less then 0
Since:
  1.6
See Also:
  `DatabaseMetaData.getClientInfoProperties()`

#### setClientInfo

    public void setClientInfo​(String name,
                              String value)
                       throws SQLClientInfoException

Sets the value of the client info property specified by name to the value specified by value.

Applications may use the `DatabaseMetaData.getClientInfoProperties` method to determine the client info properties supported by the driver and the maximum length that may be specified for each property.

The driver stores the value specified in a suitable location in the database. For example in a special register, session parameter, or system table column. For efficiency the driver may defer setting the value in the database until the next time a statement is executed or prepared. Other than storing the client information in the appropriate place in the database, these methods shall not alter the behavior of the connection in anyway. The values supplied to these methods are used for accounting, diagnostics and debugging purposes only.

The driver shall generate a warning if the client info name specified is not recognized by the driver.

If the value specified to this method is greater than the maximum length for the property the driver may either truncate the value and generate a warning or generate a `SQLClientInfoException`. If the driver generates a `SQLClientInfoException`, the value specified was not set on the connection.

The following are standard client info properties. Drivers are not required to support these properties however if the driver supports a client info property that can be described by one of the standard properties, the standard property name should be used.

- ApplicationName - The name of the application currently utilizing the connection
- ClientUser - The name of the user that the application using the connection is performing work for. This may not be the same as the user name that was used in establishing the connection.
- ClientHostname - The hostname of the computer the application using the connection is running on.

Specified by:
  `setClientInfo` in interface `Connection`
Parameters:
  `name` - The name of the client info property to set
  `value` - The value to set the client info property to. If the value is null, the current value of the specified property is cleared.
Throws:
  `SQLClientInfoException` - if the database server returns an error while setting the client info value on the database server or this method is called on a closed connection
Since:
  1.6

#### getClientInfo

    public Properties getClientInfo()
                             throws SQLException

Returns a list containing the name and current value of each client info property supported by the driver. The value of a client info property may be null if the property has not been set and does not have a default value.

Specified by:
  `getClientInfo` in interface `Connection`
Returns:
  A `Properties` object that contains the name and current value of each of the client info properties supported by the driver.
Throws:
  `SQLException` - if the database server returns an error when fetching the client info values from the database or this method is called on a closed connection

#### setClientInfo

    public void setClientInfo​(Properties properties)
                       throws SQLClientInfoException

Sets the value of the connection's client info properties. The `Properties` object contains the names and values of the client info properties to be set. The set of client info properties contained in the properties list replaces the current set of client info properties on the connection. If a property that is currently set on the connection is not present in the properties list, that property is cleared. Specifying an empty properties list will clear all of the properties on the connection. See `setClientInfo (String, String)` for more information.

If an error occurs in setting any of the client info properties, a `SQLClientInfoException` is thrown. The `SQLClientInfoException` contains information indicating which client info properties were not set. The state of the client information is unknown because some databases do not allow multiple client info properties to be set atomically. For those databases, one or more properties may have been set before the error occurred.

Specified by:
  `setClientInfo` in interface `Connection`
Parameters:
  `properties` - the list of client info properties to set
Throws:
  `SQLClientInfoException` - if the database server returns an error while setting the clientInfo values on the database server or this method is called on a closed connection
Since:
  1.6
See Also:
  `setClientInfo(String, String)`

#### getClientInfo

    public String getClientInfo​(String name)
                         throws SQLException

Returns the value of the client info property specified by name. This method may return null if the specified client info property has not been set and does not have a default value. This method will also return null if the specified client info property name is not supported by the driver. Applications may use the `DatabaseMetaData.getClientInfoProperties` method to determine the client info properties supported by the driver.

Specified by:
  `getClientInfo` in interface `Connection`
Parameters:
  `name` - The name of the client info property to retrieve
Returns:
  The value of the client info property specified
Throws:
  `SQLException` - if the database server returns an error when fetching the client info value from the database or this method is called on a closed connection
Since:
  1.6
See Also:
  `DatabaseMetaData.getClientInfoProperties()`

#### createArrayOf

    public Array createArrayOf​(String typeName,
                               Object[] elements)
                        throws SQLException

Factory method for creating Array objects. Note: When `createArrayOf` is used to create an array object that maps to a primitive data type, then it is implementation-defined whether the `Array` object is an array of that primitive data type or an array of `Object`. Note: The JDBC driver is responsible for mapping the elements `Object` array to the default JDBC SQL type defined in java.sql.Types for the given class of `Object`. The default mapping is specified in Appendix B of the JDBC specification. If the resulting JDBC type is not the appropriate type for the given typeName then it is implementation defined whether an `SQLException` is thrown or the driver supports the resulting conversion.

Specified by:
  `createArrayOf` in interface `Connection`
Parameters:
  `typeName` - the SQL name of the type the elements of the array map to. The typeName is a database-specific name which may be the name of a built-in type, a user-defined type or a standard SQL type supported by this database. This is the value returned by `Array.getBaseTypeName`
  `elements` - the elements that populate the returned object
Returns:
  an Array object whose elements map to the specified SQL type
Throws:
  `SQLException` - if a database error occurs, the JDBC type is not appropriate for the typeName and the conversion is not supported, the typeName is null or this method is called on a closed connection

#### createStruct

    public Struct createStruct​(String typeName,
                               Object[] attributes)
                        throws SQLException

Factory method for creating Struct objects.

Specified by:
  `createStruct` in interface `Connection`
Parameters:
  `typeName` - the SQL type name of the SQL structured type that this `Struct` object maps to. The typeName is the name of a user-defined type that has been defined for this database. It is the value returned by `Struct.getSQLTypeName`.
  `attributes` - the attributes that populate the returned object
Returns:
  a Struct object that maps to the given SQL type and is populated with the given attributes
Throws:
  `SQLException` - if a database error occurs, the typeName is null or this method is called on a closed connection

#### unwrap

    public <T> T unwrap​(Class<T> iface)
                 throws SQLException

Returns an object that implements the given interface to allow access to non-standard methods, or standard methods not exposed by the proxy. If the receiver implements the interface then the result is the receiver or a proxy for the receiver. If the receiver is a wrapper and the wrapped object implements the interface then the result is the wrapped object or a proxy for the wrapped object. Otherwise return the the result of calling `unwrap` recursively on the wrapped object or a proxy for that result. If the receiver is not a wrapper and does not implement the interface, then an `SQLException` is thrown.

Specified by:
  `unwrap` in interface `Wrapper`
Parameters:
  `iface` - A Class defining an interface that the result must implement.
Returns:
  an object that implements the interface. May be a proxy for the actual implementing object.
Throws:
  `SQLException` - If no object found that implements the interface
Since:
  1.6

#### isWrapperFor

    public boolean isWrapperFor​(Class<?> iface)

Returns true if this either implements the interface argument or is directly or indirectly a wrapper for an object that does. Returns false otherwise. If this implements the interface then return true, else if this is a wrapper then return the result of recursively calling `isWrapperFor` on the wrapped object. If this does not implement the interface and is not a wrapper, return false. This method should be implemented as a low-cost operation compared to `unwrap` so that callers can use this method to avoid expensive `unwrap` calls that may fail. If this method returns true then calling `unwrap` with the same argument should succeed.

Specified by:
  `isWrapperFor` in interface `Wrapper`
Parameters:
  `iface` - a Class defining an interface.
Returns:
  true if this implements the interface or directly or indirectly wraps an object that does.
Since:
  1.6

#### getUsername

    @Deprecated
    public String getUsername()

Deprecated.
returns the username for the connection.

Returns:
  the username.

#### getHostname

    @Deprecated
    public String getHostname()

Deprecated.
returns the hostname for the connection.

Returns:
  the hostname.

#### getPort

    @Deprecated
    public int getPort()

Deprecated.
returns the port for the connection.

Returns:
  the port

#### getPinGlobalTxToPhysicalConnection

    protected boolean getPinGlobalTxToPhysicalConnection()

#### setHostFailed

    public void setHostFailed()

If failover is not activated, will close connection when a connection error occur.

#### getLowercaseTableNames

    public int getLowercaseTableNames()
                               throws SQLException

Are table case sensitive or not . Default Value: 0 (Unix), 1 (Windows), 2 (Mac OS X). If set to 0 (the default on Unix-based systems), table names and aliases and database names are compared in a case-sensitive manner. If set to 1 (the default on Windows), names are stored in lowercase and not compared in a case-sensitive manner. If set to 2 (the default on Mac OS X), names are stored as declared, but compared in lowercase.

Returns:
  int value.
Throws:
  `SQLException` - if a connection error occur

#### abort

    public void abort​(Executor executor)
               throws SQLException

Abort connection.

Specified by:
  `abort` in interface `Connection`
Parameters:
  `executor` - executor
Throws:
  `SQLException` - if security manager doesn't permit it.

#### getNetworkTimeout

    public int getNetworkTimeout()
                          throws SQLException

Get network timeout.

Specified by:
  `getNetworkTimeout` in interface `Connection`
Returns:
  timeout
Throws:
  `SQLException` - if database socket error occur

#### getSchema

    public String getSchema()

Specified by:
  `getSchema` in interface `Connection`

#### setSchema

    public void setSchema​(String arg0)

Specified by:
  `setSchema` in interface `Connection`

#### setNetworkTimeout

    public void setNetworkTimeout​(Executor executor,
                                  int milliseconds)
                           throws SQLException

Change network timeout.

Specified by:
  `setNetworkTimeout` in interface `Connection`
Parameters:
  `executor` - executor (can be null)
  `milliseconds` - network timeout in milliseconds.
Throws:
  `SQLException` - if security manager doesn't permit it.

#### getServerThreadId

    public long getServerThreadId()

#### canUseServerTimeout

    public boolean canUseServerTimeout()

#### setDefaultTransactionIsolation

    public void setDefaultTransactionIsolation​(int defaultTransactionIsolation)

#### reset

    public void reset()
               throws SQLException

Reset connection set has it was after creating a "fresh" new connection. defaultTransactionIsolation must have been initialized.

BUT : - session variable state are reset only if option useResetConnection is set and - if using the option "useServerPrepStmts", PREPARE statement are still prepared

Throws:
  `SQLException` - if resetting operation failed

#### includeDeadLockInfo

    public boolean includeDeadLockInfo()

#### includeThreadsTraces

    public boolean includeThreadsTraces()